<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<title>Intel&reg; Enhanced Privacy ID SDK: What&#39;s Included in the SDK</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="epidstyle.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname"><a 
                            onclick="storeLink('index.html')"
                            id="projectlink" 
                            class="index.html" 
                            href="index.html">Intel&reg; Enhanced Privacy ID SDK</a>
&#160;<span id="projectnumber">6.0.1</span>
</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_sdk_overview.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">What's Included in the SDK </div>  </div>
</div><!--header-->
<div class="contents">
<div class="toc"><h3>Table of Contents</h3>
<ul><li class="level1"><a href="#SdkOverview_Components">SDK Components</a><ul><li class="level2"><a href="#SdkOverview_Core">SDK Core</a></li>
<li class="level2"><a href="#SdkOverview_Samples">Samples</a></li>
<li class="level2"><a href="#SdkOverview_Tools">Tools</a></li>
<li class="level2"><a href="#SdkOverview_BuildingAndValidation">Other Components</a></li>
</ul>
</li>
<li class="level1"><a href="#SdkOverview_Compatibility">Intel&reg; EPID 1.1 Compatibility</a></li>
<li class="level1"><a href="#SdkOverview_TPM">Member Implementations</a></li>
<li class="level1"><a href="#SdkOverview_Files">Folder Layout</a><ul><li class="level2"><a href="#SdkOverview_Files_SourceLayout">Source Layout</a></li>
<li class="level2"><a href="#SdkOverview_Files_InstallLayout">Install Layout</a></li>
</ul>
</li>
</ul>
</div>
<div class="textblock"><h1><a class="anchor" id="SdkOverview_Components"></a>
SDK Components</h1>
<p>The SDK is divided into logical components to separate responsibilities and create interfaces that you can re-implement using custom tools such as hardware accelerators.</p>
<div class="image">
<img src="sdk_block_diagram.png" alt="sdk_block_diagram.png"/>
</div>
<p><br />
 The Intel&reg; EPID SDK is divided into the following components:</p>
<p><br />
</p>
<h2><a class="anchor" id="SdkOverview_Core"></a>
SDK Core</h2>
<p>Components in the SDK Core implement the features of Intel&reg; EPID.</p>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">Component  </th><th class="markdownTableHeadNone">Description ------------&mdash;   </th></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">member  </td><td class="markdownTableBodyNone">Library containing APIs needed to implement a member   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowEven">
<td class="markdownTableBodyNone">verifier  </td><td class="markdownTableBodyNone">Library containing APIs needed to implement a verifier   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">common  </td><td class="markdownTableBodyNone">Library containing common types and functions   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowEven">
<td class="markdownTableBodyNone">math  </td><td class="markdownTableBodyNone">Math primitives used by member and verifier   </td></tr>
</table>
<p><br />
</p>
<h2><a class="anchor" id="SdkOverview_Samples"></a>
Samples</h2>
<p>The SDK includes <a class="el" href="_issuer_material.html">Test Data</a> in <code>example/data</code> that is intended to be provisioned in members and verifiers so that they can operate without real issuer material. (For information on how to work with real issuer material, refer to <a class="el" href="_usingi_k_g_f.html">Managing Groups with iKGF</a>.)</p>
<p>The SDK also includes signing and verification <a class="el" href="_examples.html">Examples</a> that show how to use the SDK APIs in working code.</p>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">Component  </th><th class="markdownTableHeadNone">Description ------------&mdash;   </th></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">signmsg  </td><td class="markdownTableBodyNone">A sample program showing how to sign messages   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowEven">
<td class="markdownTableBodyNone">verfifysig  </td><td class="markdownTableBodyNone">A sample program showing how to verify signatures   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">util  </td><td class="markdownTableBodyNone">Common utilities used by samples   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowEven">
<td class="markdownTableBodyNone">Sample Issuer Material  </td><td class="markdownTableBodyNone">Sample keys and revocation lists   </td></tr>
</table>
<p><br />
</p>
<h2><a class="anchor" id="SdkOverview_Tools"></a>
Tools</h2>
<p>The SDK provides tools to interact with Intel&reg; EPID related services such those offered by the <a class="el" href="_issuer_material.html">Intel&reg; Key Generation Facility</a>.</p>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">Component  </th><th class="markdownTableHeadNone">Description ------------&mdash;   </th></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">extractgrps  </td><td class="markdownTableBodyNone">A tool to extract groups from a bulk group file   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowEven">
<td class="markdownTableBodyNone">extractkeys  </td><td class="markdownTableBodyNone">A tool to extract member keys from a bulk key file   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">revokegrp  </td><td class="markdownTableBodyNone">A tool to create a revocation request for a group   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowEven">
<td class="markdownTableBodyNone">revokekey  </td><td class="markdownTableBodyNone">A tool to create a revocation request for a member key   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">revokesig  </td><td class="markdownTableBodyNone">A tool to create a revocation request from a signature   </td></tr>
</table>
<p><br />
</p>
<h2><a class="anchor" id="SdkOverview_BuildingAndValidation"></a>
Other Components</h2>
<p>The SDK comes with a number of other components that support building and validating the code.</p>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">Component  </th><th class="markdownTableHeadNone">Description ------------&mdash;   </th></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">gtest  </td><td class="markdownTableBodyNone">gtest unit test framework   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowEven">
<td class="markdownTableBodyNone">Build Scripts  </td><td class="markdownTableBodyNone">Scripts to configure and build the SDK   </td></tr>
<tr class="markdownTableBody" class="markdownTableRowOdd">
<td class="markdownTableBodyNone">dropt  </td><td class="markdownTableBodyNone">Library for parsing command line   </td></tr>
</table>
<p>Math primitives are implemented in the <em>math</em> sub-component of <em>common</em>. The reference math primitive implementation is based on a non-optimized Vanilla C subset of the Intel&reg; Performance Primitives. <em>Math</em> is designed so that you can replace its implementation to call custom hardware IP blocks or optimized libraries.</p>
<p><br />
</p>
<h1><a class="anchor" id="SdkOverview_Compatibility"></a>
Intel® EPID 1.1 Compatibility</h1>
<p>In addition to the default Intel&reg; EPID 2.0 APIs, the <em>verifier</em> component also includes APIs that allow verification of Intel&reg; EPID 1.1 signatures.</p>
<p>Billions of existing devices, including most Intel platforms manufactured since 2008, create signatures that need Intel&reg; EPID 1.1 verification.</p>
<p>For details on verifying Intel&reg; EPID 1.1 signatures see <a href="group___epid11_verifier_module.html#details"><b>Intel&reg; EPID 1.1 support</b></a> in the API Reference.</p>
<h1><a class="anchor" id="SdkOverview_TPM"></a>
Member Implementations</h1>
<p>There are three member implementations. You can use a specific compilation option to select the implementation that will be used at compile time. The implementations are:</p>
<ol type="1">
<li><b>Reference:</b> This default implementation gives guidance on partitioning member operations between highly sensitive ones that use the <code>f</code> value of the member private key, and less sensitive ones that can be performed in a host environment. To build in default mode, refer to <a class="el" href="_building_sdk.html">Building from Source</a>.</li>
<li><b>TPM:</b> This TPM member implementation uses the TPM for signing by linking to the IBM TSS. To build in TPM mode, refer to <a class="el" href="_tpm_considerations.html#TpmConsiderations_BuildingTpmMode">Building the SDK in TPM Mode</a>.</li>
<li><b>Tiny:</b> This tiny implementation builds the SDK with a substantially reduced code size. To build in tiny mode, refer to <a class="el" href="_building_sdk.html#BuildingSdk_Tiny">Optimizing for Code Size</a>.</li>
</ol>
<div class="image">
<img src="implementing_member.png" alt="implementing_member.png"/>
</div>
<h1><a class="anchor" id="SdkOverview_Files"></a>
Folder Layout</h1>
<p>The Intel&reg; EPID SDK has two filesystem layouts: the Source Layout and the Install Layout.</p>
<p>The Source Layout is what you find when you download the SDK and extract it to disk. This layout contains all of the files that you need to build the libraries, samples, tests, and data generated by the SDK.</p>
<p>The Install Layout is the layout of files under the <code>_install</code> folder after you build the SDK.</p>
<h2><a class="anchor" id="SdkOverview_Files_SourceLayout"></a>
Source Layout</h2>
<p>The Source Layout is used by the build scripts in the Intel&reg; EPID SDK to find components and files needed to create libraries and executables. </p><pre class="fragment">epid-sdk/
|__ LICENSE.txt             Distribution license
|__ NOTICE.txt              Legal notices
|__ README.md               Readme
|__ CHANGELOG.md            Change log
|__ SConstruct              Parts based build configuration
|__ configure               Make based build configuration
|__ Makefile.in             Make based build configuration
|
|__ doc/
|   |__ html/               HTML format documentation
|   |__ index.html          Entry point for HTML format documentation
|
|__ epid/
|   |__ common/             Source for Common
|   |__ common-testhelper/  Source for unit test helper common helpers
|   |__ member/             Source for Member
|   |__ verifier/           Source for Verifier
|
|__ example/
|   |__ data/               Binary data used for testing and tutorials
|   |__ compressed_data/    Compressed Member Key Binary data used for testing and tutorials
|   |__ signmsg/            Source for message signing example
|   |__ util/               Common utilities for examples
|   |__ verifysig/          Source for signature validation signing example
|
|__ ext/
|   |__ dropt/              Third party library for parsing command-line options
|   |__ gtest/              Third party gtest library
|   |__ ipp/                Intel(R) Performance Primitives library
|
|__ parts-site/             Parts platform config scripts
|
|__ tools/
    |__ extractgrps/        Tool to extract groups
    |__ extractkeys/        Tool to extract keys
    |__ revokegrp/          Tool to create group revocation request
    |__ revokekey/          Tool to create a member key revocation request
    |__ revokesig/          Tool to create a signature based revocation
                            request
</pre><h2><a class="anchor" id="SdkOverview_Files_InstallLayout"></a>
Install Layout</h2>
<p>The Install Layout contains the data developers need to develop and build their applications using the Intel&reg; EPID SDK. Once built, the Install Layout has no dependency on the Source Layout, allowing developers to build the SDK once and reuse the built files in other locations or on other computers. </p><pre class="fragment">_install/
|__ epid-sdk/
    |__ include/            C include header files for the SDK
    |__ lib/
    |   |__ &lt;platform&gt;      Target specific static libraries for the SDK
    |
    |__ example/             Sample applications and data
    |__ compressed_example/  Compressed Member Key Binary data for sample applications
    |__ test/                Unit test executables (if unit tests built)
    |__ tools/               Tools</pre> </div></div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">
      &copy; 2016-2017 Intel Corporation
    </li>
  </ul>
</div>
</body>
</html>
